/******************************************************************************
Ootake
EXN[ɂbZ[W̕\ł悤ɂBv0.64

Copyright(C)2006 Kitao Nakamura.
	ŁEpłJȂƂ͕K\[XR[hYtĂB
	̍ۂɎł܂܂̂ŁAЂƂƂm点ƍKłB
	Iȗp͋ւ܂B
	Ƃ́uGNU General Public License(ʌOp_)vɏ܂B

*******************************************************************************
	[Printf.c]

		Implements a printf function which displays a text on the
	main window's title bar.

	Copyright (C) 2005 Ki

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
******************************************************************************/
#include <stdio.h>
#include <stdarg.h>
#include "Printf.h"
#include "WinMain.h"
#include "Screen.h" //Kitaoǉ
#include "App.h" //Kitaoǉ
#include "MainBoard.h" //Kitaoǉ


#define PRINTF_MESSAGE_MAX		60*8		/* frames */ //KitaoύX

static char						_MessageBuffer[2048];
static Uint32					_FrameCount = 0;


/*----------------------------------------------------------------------------
	[PRINTF]
		Displays a text message for several seconds.
----------------------------------------------------------------------------*/
void
PRINTF(
	const char*		pMessage, ...)
{
	va_list			ap;

	va_start(ap, pMessage);
	vsprintf(_MessageBuffer, pMessage, ap);
	va_end(ap);

	while (strchr(_MessageBuffer, '\n'))
		*strchr(_MessageBuffer, '\n') = '\0';

	//puts(_MessageBuffer);
	//KitaoǉBXN[ւ̃bZ[W\\ɁB
	if (APP_GetFullScreen())
	{
		if (!APP_GetFullHideMessage())
			SCREEN_SetMessageText(_MessageBuffer);
	}
	else
	{
		if (APP_GetHideMessage())
			WINMAIN_SetCaption(_MessageBuffer);
		else
			SCREEN_SetMessageText(_MessageBuffer);
	}
	_FrameCount = 0;
}


inline void
PRINTF_Update()
{
	if (++_FrameCount == PRINTF_MESSAGE_MAX)
	{
		if (MAINBOARD_GetPause())  //KitaoǉBPAUSE̓bZ[WȂB
			--_FrameCount;
		else
		{
			WINMAIN_SetCaption(NULL);
			SCREEN_SetMessageText(""); //Kitaoǉ
		}
	}
}


BOOL
PRINTF_Init()
{
	SCREEN_SetMessageText(""); //Kitaoǉ
	_FrameCount = 0;
	return TRUE;
}


void
PRINTF_Deinit()
{
	_FrameCount = 0;
}

